#ifndef WRAPPER_H
#define WRAPPER_H

#define EBUG
/* #define EBUG_WRAPPER */
#define MALLOC_MAGIC_WRAPPER
#define MALLOC_MAGIC 0x0badf00d
#define MEM_HASH_SIZE 509

struct memory_ll {
	size_t size;
#ifdef EBUG
	int line;
	char *file;
#endif
	void *ptr;
	struct memory_ll *next;
	struct memory_ll *prev;
}        *memory[MEM_HASH_SIZE];

#undef match
#define match(x, y) (strcasecmp(x, y) == 0)
#define my_malloc(x) my_malloc_child(x, __LINE__, __FILE__)
#define my_free(x) my_free_child(x, __LINE__, __FILE__)
#define my_realloc(x,y) my_realloc_child(x, y, __LINE__, __FILE__)
#define my_strdup(x) my_strdup_child(x, __LINE__, __FILE__)

void	*my_malloc_child(size_t, int, const char *),
	*my_realloc_child(void *, size_t, int, const char *),
	my_free_child(void *, int, const char *),
	log_memory_in_use(void);
char	*my_strdup_child(const char *, int, const char *);
struct	memory_ll *find_memory_by_pointer(void *);
size_t	get_memory_usage(char *);
long	get_memory_allocated(char *);


#ifdef MALLOC_MAGIC_CHECK
void *add_magic(void *, int);

#endif
#endif /* WRAPPER_H */
